//basics (background, logo etc.)
void format() {
  // background
  noStroke();
  fill(backgroundColor);
  rect(startX, startY, base, baseY);
  
  // logo
  image(logo, base - baseY / 8 - barSize + startX, startY + logo.height/2);
  
  // button
  if (radioButtons) {
    fill (notActiveColor);
  } else {
    fill(disabledColor);
  }
  rect(base - 4 * dBarSize + startX, buttonY[5] - 3 * hBarSize, 3 * dBarSize, dBarSize);
  
  fill(stripeColor);
  textFont (font, 3 * hBarSize);
  textAlign(CENTER);
  if(finalPage) {
    text("SAVE", base - 5 * barSize + startX, buttonY[5]); 
  } else {
    text("->", base - 5 * barSize + startX, buttonY[5]); 
  }
  textAlign(LEFT);
  text("ID: " + userID, barSize + startX, buttonY[5]);
  
  // separation line
  rect(barSize + startX, baseY/8 + startY, base - dBarSize, eBarSize);
  if (radioButtons) {
    rect(barSize + startX, baseY/2 + startY, base - dBarSize, eBarSize);
  }
  
  createNext = true;
  testButtons = true;
  finalPage = false;
  grapActive = false;
  nextPage = false;
  changeMapping = false;
  textileActive = false;
  saveComment = false;
  
  startButton = 0;
  numberQuestions = generalNumberQuestions;
  numberButtons = generalNumberButtons;

  for (int i=0; i<numberQuestions; i++) {
    storedValues[i] = numberButtons + 1;
  }
}

//toggle
void plotToggle(boolean active) {
  noStroke();
  if (active) {
    if (toggled) {
      fill(enabledColor);
    } else {
      fill(disabledColor);
    }
  } else {
    fill(notActiveColor);
  }
  ellipse(toggleX, toggleY, toggleSizeX, toggleSizeX);
  fill(stripeColor);
  textFont (font, 3 * hBarSize);
  textAlign(CENTER);
  text("||/>", 6 * barSize + startX, toggleY + hBarSize);
}

void targetToggle(color targetColor) {
  noFill();
  //noSmooth();
  stroke(targetColor);
  if (targetColor == backgroundColor) {
    strokeWeight(eBarSize + 2);
  } else {
    strokeWeight(eBarSize);
  }
  ellipse(toggleX, toggleY, toggleBarSizeX, toggleBarSizeX);
  //smooth();
}

void plotScroll(boolean active) {
  noStroke();
  if (active) {
    fill(disabledColor);
  } else {
    fill(notActiveColor);
  }
  rect(scrollX, scrollY, scrollSizeX, barSize);
  if (active) {
    for (int i = 0; i<counterScroll; i++) {
      noStroke();
      fill(enabledColor);
      rect(scrollX + i * hBarSize, scrollY, hBarSize, barSize);
    }
  }
  fill(stripeColor);
  textFont (font, 3 * hBarSize);
  textAlign(CENTER);
  text("Vol +/-", 6 * barSize + startX, scrollY + barSize);
}

// scroll
void scrollRight() {
  if (counterScroll < scrollSizeX / hBarSize) {
    noStroke();
    fill(enabledColor);
    rect(scrollX + counterScroll * hBarSize, scrollY, hBarSize, barSize);
    counterScroll++;
  }
}

void scrollLeft() {
  if (counterScroll > 0) {
    noStroke();
    fill(disabledColor);
    counterScroll--;
    rect(scrollX + counterScroll * hBarSize, scrollY, hBarSize, barSize);
  }
}

void targetScroll(int targetPosition, int targetSize, color targetColor) {
  noFill();
  noSmooth();
  stroke(targetColor);
  strokeWeight(eBarSize);
  rect(scrollX + targetPosition, scrollY - hBarSize, targetSize, dBarSize);
  smooth();
}

// step
void plotStep(boolean active) {
  for (int i = 0; i < numberSteps; i++) {
    noStroke();
    if (active) {
      fill(disabledColor);
    } else {
      fill(notActiveColor);
    }
    rect(stepX + i * stepBarSizeX, stepY, stepSizeX, barSize);
  } 
  if (active) { // fill first step
    for (int i = 0; i<counterStep; i++) {
      noStroke();
      fill(enabledColor);
      rect(stepX + i * stepBarSizeX, stepY, stepSizeX, barSize);
    }
  }
  fill(stripeColor);
  textFont (font, 3 * hBarSize);
  textAlign(CENTER);
  text("|</>|", 6 * barSize + startX, stepY + barSize);
}

void stepRight() {
  if (counterStep < numberSteps) {
    noStroke();
    fill(enabledColor);
    rect(stepX + counterStep * stepBarSizeX, stepY, stepSizeX, barSize);
    counterStep++;
  }
}

void stepLeft() {
  if (counterStep > 1) {
    noStroke();
    fill(disabledColor);
    counterStep--;
    rect(stepX + counterStep * stepBarSizeX, stepY, stepSizeX, barSize);
  }
}

void targetStep(int targetNumber, color targetColor) {
  noFill();
  noSmooth();
  stroke(targetColor);
  strokeWeight(eBarSize);
  rect(stepX + targetNumber * stepBarSizeX - hBarSize, stepY - hBarSize, stepBarSizeX, dBarSize);
  smooth();
}

//targets
// create target
void createTarget() {
  if (createNext) {
    notValid = true;
    if (act == 1) {
      act = 0;
      prev = 1;
    } else {
      act = 1;
      prev = 0;
    }
    while (notValid) {
      createValues();
      if ((selectType[act] == 0) && toggleActive && (selectType[prev] != 0)) {
        notValid = false;
      } else if ((selectType[act] == 1) && stepActive && (selectStep[prev] != selectStep[act]) && (counterStep != selectStep[act])) {
        notValid = false;
      } else if ((selectType[act] == 2) && scrollActive && (!((counterScroll >= selectPosition[act]) && (counterScroll <= selectPosition[act] + selectSize[act])))) {
        notValid = false;
      }
    }
    
    if (selectType[act] == 0) {
      targetToggle(stripeColor);
      saveToggle = toggled;
      //println("Toggle expected: " + (!saveToggle));
      store("\nToggle expected: " + (!saveToggle));
      store("\nActual value: " + saveToggle);
    } else if (selectType[act] == 1) {
      targetStep(selectStep[act], stripeColor);
      //println("Step expected: " +  selectStep[act]);
      store("\nStep expected: " +  selectStep[act]);
      store("\nActual value: " + counterStep);
    } else if (selectType[act] == 2) {
      targetScroll(selectPosition[act] * hBarSize, selectSize[act] * hBarSize, stripeColor);
      //println("Scroll expected: " + selectPosition[act] + " , " + selectSize[act]);
      store("\nScroll expected: " + selectPosition[act] + " , " + selectSize[act]);
      store("\nActual value: " + counterScroll);
    }
    time = millis();
    createNext = false;
  }
}

// remove target
void clearTarget() {
  if ((selectType[act] == 0) && (saveToggle != toggled)) {
    targetToggle(backgroundColor);
    cleanUp();
  } else if ((selectType[act] == 1) && (counterStep-1 == selectStep[act])) {
    targetStep(selectStep[act], backgroundColor);
    cleanUp();
  } else if ((selectType[act] == 2) && (counterScroll > selectPosition[act]-1) && (counterScroll < selectPosition[act] + selectSize[act]+1)) {
    targetScroll(selectPosition[act] * hBarSize, selectSize[act] * hBarSize, backgroundColor);
    plotScroll(true);
    cleanUp();
  }
}

void cleanUp() {
  createNext = !createNext;
  store("\nTime: " + (millis() - time));
}

void createValues() {
  selectType[act] = (int)random(3);
  //println(selectType);
  selectStep[act] = (int)random(numberSteps);
  //println(selectStep);
  selectPosition[act] = (int)random(scrollSizeX / hBarSize - 20);
  selectSize[act] = (int)random(2, 20);
  //println(selectPosition);
  //println(selectSize);
}
